"use strict";

var _interopRequireWildcard = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireWildcard").default;
var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
var _IconButton = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/IconButton"));
var _Menu = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@sinoui/core/Menu"));
var _Popper = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/Popper"));
var _useClickAwayListener = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/useClickAwayListener"));
var _BorderAll = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/BorderAll"));
var _BorderBottom = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/BorderBottom"));
var _BorderClear = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/BorderClear"));
var _BorderHorizontal = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/BorderHorizontal"));
var _BorderInner = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/BorderInner"));
var _BorderLeft = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/BorderLeft"));
var _BorderOuter = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/BorderOuter"));
var _BorderRight = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/BorderRight"));
var _BorderTop = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/BorderTop"));
var _BorderVertical = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/BorderVertical"));
var _Edit = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/Edit"));
var _PowerInput = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/PowerInput"));
var _react = /*#__PURE__*/require("react");
var _reactColor = /*#__PURE__*/require("react-color");
var _reactRedux = /*#__PURE__*/require("react-redux");
var _styledComponents = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("styled-components"));
var _constants = /*#__PURE__*/require("../../constants");
var _reducer = /*#__PURE__*/require("../../reducer");
var _Line = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./Line"));
/* eslint-disable react/display-name */

var Layout = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "BorderConfigPanel__Layout",
  componentId: "sc-4evtlb-0"
})(["width:200px;display:flex;background:#fff;box-shadow:0px 2px 10px #999999;"]);
var BorderTypeWrapper = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "BorderConfigPanel__BorderTypeWrapper",
  componentId: "sc-4evtlb-1"
})(["flex:5;display:flex;flex-wrap:wrap;"]);
var BorderStyleWrapper = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "BorderConfigPanel__BorderStyleWrapper",
  componentId: "sc-4evtlb-2"
})(["flex:1;border-left:1px solid #eee;"]);
var PickerPanelWrapper = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "BorderConfigPanel__PickerPanelWrapper",
  componentId: "sc-4evtlb-3"
})(["position:absolute;z-index:2;box-shadow:0px 2px 10px #999999;margin-left:2px;"]);
var checkSingleCell = function checkSingleCell(selectedRange) {
  var merges = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  if (!selectedRange) {
    return false;
  }
  if (selectedRange[0][0] === selectedRange[1][0] && selectedRange[0][1] === selectedRange[1][1]) {
    return true;
  }
  return merges.some(function (_ref) {
    var _ref2 = (0, _slicedToArray2.default)(_ref, 2),
      _ref2$ = (0, _slicedToArray2.default)(_ref2[0], 2),
      msri = _ref2$[0],
      msci = _ref2$[1],
      _ref2$2 = (0, _slicedToArray2.default)(_ref2[1], 2),
      meri = _ref2$2[0],
      meci = _ref2$2[1];
    return msri === selectedRange[0][0] && msci === selectedRange[0][1] && meri === selectedRange[1][0] && meci === selectedRange[1][1];
  });
};
var _default = function _default(_ref3) {
  var selectedRange = _ref3.selectedRange,
    borderType = _ref3.borderType,
    setBorderType = _ref3.setBorderType,
    borderStyle = _ref3.borderStyle,
    borderColor = _ref3.borderColor,
    setBorderStyle = _ref3.setBorderStyle,
    setBorderColor = _ref3.setBorderColor;
  var merges = (0, _reactRedux.useSelector)(function (state) {
    return state.present.merges;
  });
  var dispatch = (0, _reactRedux.useDispatch)();
  var lineEl = (0, _react.useRef)(null);
  var colorPopperRef = (0, _react.useRef)(null);
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    lineOpen = _useState2[0],
    setLineOpen = _useState2[1];
  var colorEl = (0, _react.useRef)(null);
  var _useState3 = (0, _react.useState)(false),
    _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
    colorOpen = _useState4[0],
    setColorOpen = _useState4[1];
  var isSingleCell = (0, _react.useMemo)(function () {
    return checkSingleCell(selectedRange, merges);
  }, [selectedRange, merges]);
  var handleBorderClick = function handleBorderClick(type) {
    setBorderType(type);
    if (!selectedRange) return;
    dispatch((0, _reducer.setCellsBorderStyle)(selectedRange, type, [borderStyle, borderColor]));
  };
  var handleColorChange = function handleColorChange(colorInfo) {
    setBorderColor(colorInfo.hex);
    setColorOpen(false);
    if (!selectedRange || !borderType) return;
    dispatch((0, _reducer.setCellsBorderStyle)(selectedRange, borderType, [borderStyle, colorInfo.hex]));
  };
  var handleBorderStyleChange = function handleBorderStyleChange(type) {
    setBorderStyle(type);
    setLineOpen(false);
    if (!selectedRange || !borderType) return;
    dispatch((0, _reducer.setCellsBorderStyle)(selectedRange, borderType, [type, borderColor]));
  };
  (0, _useClickAwayListener.default)([colorPopperRef], function () {
    return setColorOpen(false);
  });
  return (0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [(0, _jsxRuntime.jsxs)(Layout, {
      children: [(0, _jsxRuntime.jsxs)(BorderTypeWrapper, {
        children: [(0, _jsxRuntime.jsx)(_IconButton.default, {
          dense: true,
          onClick: function onClick() {
            return handleBorderClick(_constants.BorderType.BORDER_ALL);
          },
          children: (0, _jsxRuntime.jsx)(_BorderAll.default, {})
        }), (0, _jsxRuntime.jsx)(_IconButton.default, {
          disabled: isSingleCell,
          dense: true,
          onClick: function onClick() {
            return handleBorderClick(_constants.BorderType.BORDER_INNER);
          },
          children: (0, _jsxRuntime.jsx)(_BorderInner.default, {})
        }), (0, _jsxRuntime.jsx)(_IconButton.default, {
          disabled: isSingleCell,
          dense: true,
          onClick: function onClick() {
            return handleBorderClick(_constants.BorderType.BORDER_HORIZONTAL);
          },
          children: (0, _jsxRuntime.jsx)(_BorderHorizontal.default, {})
        }), (0, _jsxRuntime.jsx)(_IconButton.default, {
          disabled: isSingleCell,
          dense: true,
          onClick: function onClick() {
            return handleBorderClick(_constants.BorderType.BORDER_VERTICAL);
          },
          children: (0, _jsxRuntime.jsx)(_BorderVertical.default, {})
        }), (0, _jsxRuntime.jsx)(_IconButton.default, {
          dense: true,
          onClick: function onClick() {
            return handleBorderClick(_constants.BorderType.BORDER_OUTER);
          },
          children: (0, _jsxRuntime.jsx)(_BorderOuter.default, {})
        }), (0, _jsxRuntime.jsx)(_IconButton.default, {
          dense: true,
          onClick: function onClick() {
            return handleBorderClick(_constants.BorderType.BORDER_LEFT);
          },
          children: (0, _jsxRuntime.jsx)(_BorderLeft.default, {})
        }), (0, _jsxRuntime.jsx)(_IconButton.default, {
          dense: true,
          onClick: function onClick() {
            return handleBorderClick(_constants.BorderType.BORDER_TOP);
          },
          children: (0, _jsxRuntime.jsx)(_BorderTop.default, {})
        }), (0, _jsxRuntime.jsx)(_IconButton.default, {
          dense: true,
          onClick: function onClick() {
            return handleBorderClick(_constants.BorderType.BORDER_RIGHT);
          },
          children: (0, _jsxRuntime.jsx)(_BorderRight.default, {})
        }), (0, _jsxRuntime.jsx)(_IconButton.default, {
          dense: true,
          onClick: function onClick() {
            return handleBorderClick(_constants.BorderType.BORDER_BOTTOM);
          },
          children: (0, _jsxRuntime.jsx)(_BorderBottom.default, {})
        }), (0, _jsxRuntime.jsx)(_IconButton.default, {
          dense: true,
          onClick: function onClick() {
            return handleBorderClick(_constants.BorderType.BORDER_CLEAR);
          },
          children: (0, _jsxRuntime.jsx)(_BorderClear.default, {})
        })]
      }), (0, _jsxRuntime.jsxs)(BorderStyleWrapper, {
        children: [(0, _jsxRuntime.jsx)(_IconButton.default, {
          dense: true,
          onClick: function onClick() {
            return setColorOpen(true);
          },
          ref: colorEl,
          children: (0, _jsxRuntime.jsx)(_Edit.default, {})
        }), (0, _jsxRuntime.jsx)(_IconButton.default, {
          dense: true,
          onClick: function onClick() {
            setLineOpen(true);
          },
          ref: lineEl,
          children: (0, _jsxRuntime.jsx)(_PowerInput.default, {})
        })]
      })]
    }), (0, _jsxRuntime.jsx)(_Popper.default, {
      open: colorOpen,
      referenceElement: colorEl,
      placement: "bottom-start",
      ref: colorPopperRef,
      children: (0, _jsxRuntime.jsx)(PickerPanelWrapper, {
        children: (0, _jsxRuntime.jsx)(_reactColor.SketchPicker, {
          color: borderColor,
          onChange: handleColorChange,
          className: _constants.SECOND_LEVEL_MENU
        })
      })
    }), (0, _jsxRuntime.jsxs)(_Menu.default, {
      open: lineOpen,
      referenceElement: lineEl,
      MenuListProps: {
        className: _constants.SECOND_LEVEL_MENU
      },
      children: [(0, _jsxRuntime.jsx)(_Menu.MenuListItem, {
        onClick: function onClick() {
          return handleBorderStyleChange('thin');
        },
        children: (0, _jsxRuntime.jsx)(_Line.default, {})
      }), (0, _jsxRuntime.jsx)(_Menu.MenuListItem, {
        onClick: function onClick() {
          return handleBorderStyleChange('medium');
        },
        children: (0, _jsxRuntime.jsx)(_Line.default, {
          strokeWidth: 2
        })
      }), (0, _jsxRuntime.jsx)(_Menu.MenuListItem, {
        onClick: function onClick() {
          return handleBorderStyleChange('thick');
        },
        children: (0, _jsxRuntime.jsx)(_Line.default, {
          strokeWidth: 3
        })
      }), (0, _jsxRuntime.jsx)(_Menu.MenuListItem, {
        onClick: function onClick() {
          return handleBorderStyleChange('dashed');
        },
        children: (0, _jsxRuntime.jsx)(_Line.default, {
          strokeDasharray: 2
        })
      }), (0, _jsxRuntime.jsx)(_Menu.MenuListItem, {
        onClick: function onClick() {
          return handleBorderStyleChange('dotted');
        },
        children: (0, _jsxRuntime.jsx)(_Line.default, {
          strokeDasharray: 1
        })
      })]
    })]
  });
};
exports.default = _default;