/// <reference types="react" />
import { Editor } from 'slate';
import { CellRange } from '../../reducer';
/**
 * 判断指定样式是否已在选中区域中设置的hook
 *
 * @param style 样式名称
 * @param selectedRange 选中的单元格区域
 * @param isActiveCallback 选中的单元格区域是否有指定样式的回调函数
 * @returns 返回指定样式是否已设置
 */
export default function useSingleStyleActive(style: string, selectedRange: CellRange | undefined, isActiveCallback: (editor: Editor) => boolean): [boolean, React.Dispatch<React.SetStateAction<boolean>>];
