import React from 'react';
import { LayoutFieldItem, ParagraphElement } from '@sinoform/types';
import { CustomEditor } from '../../dev';
export interface Props {
    /**
     * 编辑器的值
     */
    value?: ParagraphElement[];
    /**
     * 背景颜色
     */
    bgColor?: string;
    /**
     * 单元格宽度
     */
    width?: number;
    /**
     * 编辑器所在的行
     */
    rowIdx: number;
    /**
     * 编辑器所在列
     */
    colIdx: number;
    fields?: LayoutFieldItem[];
    /**
     * 编辑器状态集合
     */
    editor: CustomEditor;
    /**
     * 是否是只读状态
     */
    readOnly?: boolean;
}
export interface TokenType {
    type: string;
    start: number;
    end: number;
    error?: boolean;
    title?: string;
}
/**
 * 文本编辑器
 * @param props
 * @returns
 */
declare function SlateEditor(props: Props): JSX.Element;
declare const _default: React.MemoExoticComponent<typeof SlateEditor>;
export default _default;
