/// <reference types="node" />
import { EventEmitter } from 'events';
export declare const DEFAULT_PADDING_HORIZONTAL = 23.7;
export declare const DEFAULT_MENU_WIDTH = 100;
export declare const DEFAULT_MENU_HEIGHT: number;
export declare const MIN_CELL_HEIGHT = 20;
export declare enum BorderType {
    /**
     * 全边框
     */
    BORDER_ALL = "BORDER_ALL",
    /**
     * 内边框
     */
    BORDER_INNER = "BORDER_INNER",
    /**
     * 水平边框
     */
    BORDER_HORIZONTAL = "BORDER_HORIZONTAL",
    /**
     * 垂直边框
     */
    BORDER_VERTICAL = "BORDER_VERTICAL",
    /**
     * 外边框
     */
    BORDER_OUTER = "BORDER_OUTER",
    /**
     * 左边框
     */
    BORDER_LEFT = "BORDER_LEFT",
    /**
     * 上边框
     */
    BORDER_TOP = "BORDER_TOP",
    /**
     * 右边框
     */
    BORDER_RIGHT = "BORDER_RIGHT",
    /**
     * 下边框
     */
    BORDER_BOTTOM = "BORDER_BOTTOM",
    /**
     * 无边框
     */
    BORDER_CLEAR = "BORDER_CLEAR"
}
export declare const PRINT_LAYOUT_DRAG_ITEM = "PRINT_LAYOUT_DRAG_ITEM";
export declare const SPYJ: {
    id: string;
    fieldName: string;
    title: string;
    type: string;
};
export declare const PAGE_SIZES: string[];
export declare const eventbus: EventEmitter;
/**
 * 编辑器改变事件名称
 */
export declare const EDITOR_CHANGE = "editorChange";
export declare const SECOND_LEVEL_MENU = "second-level-menu";
