import { jsx as _jsx } from "react/jsx-runtime";
import React from 'react';
import StrikethroughS from '@sinoui/icons/StrikethroughS';
import { useDispatch, useSelector } from 'react-redux';
import setCellTextStyleHelper from '../../utils/setCellTextStyleHelper';
import DenseIconButton from './DenseIconButton';
import CustomEditor from '../../utils/CustomEditor';
import useSingleStyleActive from './useSingleStyleState';
/**
 * 删除线
 */
function FormatDeleteLinedButton({ editor = {}, selectedRange, editingCell, }) {
    const dispatch = useDispatch();
    const rows = useSelector((state) => state.present.rows);
    const merges = useSelector((state) => state.present.merges);
    const [isActive, setIsActive] = useSingleStyleActive('deleteLine', selectedRange, CustomEditor.isDeleteLineMarkActive);
    const handleMouseDown = (event) => {
        event.preventDefault();
        if (!editingCell) {
            setIsActive(!isActive);
        }
        setCellTextStyleHelper(editor, dispatch, 'deleteLine', '', rows, merges, selectedRange, editingCell);
    };
    return (_jsx(DenseIconButton, { dense: true, onMouseDown: handleMouseDown, isActive: isActive, children: _jsx(StrikethroughS, {}) }));
}
export default React.memo(FormatDeleteLinedButton);
