import { jsx as _jsx } from "react/jsx-runtime";
import React from 'react';
import FormatItalic from '@sinoui/icons/FormatItalic';
import { useDispatch, useSelector } from 'react-redux';
import setCellTextStyleHelper from '../../utils/setCellTextStyleHelper';
import DenseIconButton from './DenseIconButton';
import CustomEditor from '../../utils/CustomEditor';
import useSingleStyleActive from './useSingleStyleState';
/**
 * 字体倾斜样式按钮
 */
function FormatItalicButton({ editor = {}, selectedRange, editingCell, }) {
    const dispatch = useDispatch();
    const rows = useSelector((state) => state.present.rows);
    const merges = useSelector((state) => state.present.merges);
    const [isItalic, setIsItalic] = useSingleStyleActive('italic', selectedRange, CustomEditor.isItalicActive);
    const handleMouseDown = (event) => {
        event.preventDefault();
        if (!editingCell) {
            setIsItalic(!isItalic);
        }
        setCellTextStyleHelper(editor, dispatch, 'italic', '', rows, merges, selectedRange, editingCell);
    };
    return (_jsx(DenseIconButton, { dense: true, onMouseDown: handleMouseDown, isActive: isItalic, children: _jsx(FormatItalic, {}) }));
}
export default React.memo(FormatItalicButton);
