import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import IconButton from '@sinoui/core/IconButton';
import Menu, { MenuListItem } from '@sinoui/core/Menu';
import VerticalAlignBottom from '@sinoui/icons/VerticalAlignBottom';
import VerticalAlignCenter from '@sinoui/icons/VerticalAlignCenter';
import VerticalAlignTop from '@sinoui/icons/VerticalAlignTop';
import { useRef, useState } from 'react';
import { useDispatch, useSelector } from 'react-redux';
import { setCellsStyle } from '../../reducer';
import getAllSelectedCells from '../../utils/getAllSelectedCells';
export default function VerticalSelectButton({ selectedRange, disabled, }) {
    const [value, setValue] = useState('center');
    const [open, setOpen] = useState(false);
    const anchorEl = useRef(null);
    const dispatch = useDispatch();
    const merges = useSelector((state) => state.present.merges);
    const handleClick = (val) => {
        setValue(val);
        setOpen(false);
        if (!selectedRange)
            return;
        const cells = getAllSelectedCells(selectedRange, merges);
        dispatch(setCellsStyle(cells, { vertical: val }));
    };
    const render = () => {
        if (value === 'flex-start') {
            return _jsx(VerticalAlignTop, {});
        }
        if (value === 'center') {
            return _jsx(VerticalAlignCenter, {});
        }
        return _jsx(VerticalAlignBottom, {});
    };
    return (_jsxs(_Fragment, { children: [_jsx(IconButton, { style: { borderRadius: 0 }, dense: true, onClick: () => setOpen(true), ref: anchorEl, disabled: disabled, children: render() }), _jsxs(Menu, { open: open, referenceElement: anchorEl, onRequestClose: () => setOpen(false), dense: true, children: [_jsx(MenuListItem, { onClick: () => handleClick('flex-start'), children: _jsx(VerticalAlignTop, {}) }), _jsx(MenuListItem, { dense: true, onClick: () => handleClick('center'), children: _jsx(VerticalAlignCenter, {}) }), _jsx(MenuListItem, { dense: true, onClick: () => handleClick('flex-end'), children: _jsx(VerticalAlignBottom, {}) })] })] }));
}
