import { useEffect } from 'react';
import useEventCallback from '@sinoui/core/utils/useEventCallback';
export default function useListenEvent(eventbus, eventName, callback) {
    const handleEvent = useEventCallback((event) => {
        callback(event);
    });
    useEffect(() => {
        eventbus.on(eventName, handleEvent);
        return () => {
            eventbus.removeListener(eventName, handleEvent);
        };
    }, [eventName, eventbus, handleEvent]);
}
