import { jsx as _jsx } from "react/jsx-runtime";
import styled from 'styled-components';
const ItemLayout = styled.div `
  width: 100%;
  font-size: 14px;
  height: 28px;
  line-height: 28px;
  margin-top: 8px;
  padding-left: ${(props) => props.level * 20}px;
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
  cursor: move;
`;
const ItemText = styled.div `
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
`;
export default function FieldItem({ item, level }) {
    const handleDragStart = (event) => {
        event.dataTransfer.setData('field', JSON.stringify(item));
    };
    return (_jsx(ItemLayout, { draggable: !item.forbidden ? 'true' : 'false', level: level, onDragStart: handleDragStart, children: _jsx(ItemText, { children: item.title }) }));
}
