/**
 * 获取单元格选中区域所有有效的值
 * 即：单元格内容的每行数据不能都是空字符串
 *
 * @param range
 * @param config
 * @returns
 */
export default function getCellValueInRange(range, config) {
    const [fromCell, toCell] = range;
    const result = [];
    for (let i = fromCell[0]; i <= toCell[0]; i += 1) {
        for (let j = fromCell[1]; j <= toCell[1]; j += 1) {
            if (config.rows[i]?.cells?.[j]?.value) {
                const flag = config.rows[i].cells[j]?.value?.some((cellValue) => {
                    const { children = [] } = cellValue;
                    return children.some((item) => !!item.text.trim());
                });
                if (flag) {
                    result.push(config.rows[i].cells[j].value);
                }
            }
        }
    }
    return result;
}
