"use strict";

var _interopRequireWildcard = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireWildcard").default;
var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
var _Button = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/Button"));
var _Dialog = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/Dialog"));
var _DialogContent = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/DialogContent"));
var _DialogTitle = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/DialogTitle"));
var _IconButton = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/IconButton"));
var _react = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("react"));
var _reactRedux = /*#__PURE__*/require("react-redux");
var _styledComponents = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("styled-components"));
var _reducer = /*#__PURE__*/require("../../reducer");
var _getCellValueInRange = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../../reducer/helper/getCellValueInRange"));
var _MergeIcon = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./MergeIcon"));
var StyledButton = /*#__PURE__*/(0, _styledComponents.default)(_Button.default).withConfig({
  displayName: "MergeButton__StyledButton",
  componentId: "sc-wcxkoe-0"
})(["margin:0 10px;"]);
var StyledButtonBox = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "MergeButton__StyledButtonBox",
  componentId: "sc-wcxkoe-1"
})(["min-height:52px;flex:0 0 auto;display:flex;flex-direction:row;justify-content:center;"]);
var hasMergedCellInRange = function hasMergedCellInRange(range) {
  var merges = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return merges.find(function (_ref) {
    var _ref2 = (0, _slicedToArray2.default)(_ref, 2),
      _ref2$ = (0, _slicedToArray2.default)(_ref2[0], 2),
      sri = _ref2$[0],
      sci = _ref2$[1],
      _ref2$2 = (0, _slicedToArray2.default)(_ref2[1], 2),
      eri = _ref2$2[0],
      eci = _ref2$2[1];
    return sri >= range[0][0] && sci >= range[0][1] && eri <= range[1][0] && eci <= range[1][1];
  });
};
function MergeButton(_ref3) {
  var selectedRange = _ref3.selectedRange,
    disabled = _ref3.disabled;
  var dispatch = (0, _reactRedux.useDispatch)();
  var config = (0, _reactRedux.useSelector)(function (state) {
    return state.present;
  });
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var handleClick = function handleClick() {
    if (!selectedRange) return;
    if (hasMergedCellInRange(selectedRange, config.merges)) {
      // 单元格取消合并
      dispatch((0, _reducer.mergeCells)(selectedRange[0], selectedRange[1]));
      return;
    }
    // 对需要合并的单元格进行单元格的内容判定
    var cellValues = (0, _getCellValueInRange.default)(selectedRange, config);
    if (cellValues.length > 1) {
      setOpen(true);
      return;
    }
    dispatch((0, _reducer.mergeCells)(selectedRange[0], selectedRange[1]));
  };
  var handleOk = function handleOk() {
    setOpen(false);
    if (!selectedRange) return;
    dispatch((0, _reducer.mergeCells)(selectedRange[0], selectedRange[1]));
  };
  return (0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [(0, _jsxRuntime.jsx)(_IconButton.default, {
      dense: true,
      onClick: handleClick,
      disabled: disabled,
      children: (0, _jsxRuntime.jsx)(_MergeIcon.default, {
        viewBox: "0 0 1024 1024"
      })
    }), (0, _jsxRuntime.jsxs)(_Dialog.default, {
      open: open,
      onClose: function onClose() {
        return setOpen(false);
      },
      showCloseIcon: true,
      backdropClick: false,
      children: [(0, _jsxRuntime.jsx)(_DialogTitle.default, {
        children: "\u5408\u5E76\u5355\u5143\u683C"
      }), (0, _jsxRuntime.jsx)(_DialogContent.default, {
        children: "\u5408\u5E76\u5355\u5143\u683C\u65F6\uFF0C\u4EC5\u4FDD\u7559\u5DE6\u4E0A\u89D2\u7684\u503C\uFF0C\u800C\u653E\u5F03\u5176\u4ED6\u503C\u3002"
      }), (0, _jsxRuntime.jsxs)(StyledButtonBox, {
        children: [(0, _jsxRuntime.jsx)(StyledButton, {
          raised: true,
          onClick: handleOk,
          children: "\u786E\u8BA4"
        }), (0, _jsxRuntime.jsx)(StyledButton, {
          raised: true,
          onClick: function onClick() {
            return setOpen(false);
          },
          children: "\u53D6\u6D88"
        })]
      })]
    })]
  });
}
var _default = /*#__PURE__*/_react.default.memo(MergeButton);
exports.default = _default;