"use strict";

var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = UndoButton;
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
var _IconButton = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/IconButton"));
var _Undo = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/Undo"));
var _react = /*#__PURE__*/require("react");
var _reactRedux = /*#__PURE__*/require("react-redux");
var _reduxUndo = /*#__PURE__*/require("redux-undo");
/**
 * 撤销按钮
 *
 * @returns
 */
function UndoButton() {
  var dispatch = (0, _reactRedux.useDispatch)();
  var history = (0, _reactRedux.useSelector)(function (state) {
    return state.past;
  });
  var handleClick = function handleClick() {
    dispatch(_reduxUndo.ActionCreators.undo());
  };
  var disabled = (0, _react.useMemo)(function () {
    return history.length === 0;
  }, [history.length]);
  return (0, _jsxRuntime.jsx)(_IconButton.default, {
    style: {
      borderRadius: 0
    },
    dense: true,
    onClick: handleClick,
    disabled: disabled,
    children: (0, _jsxRuntime.jsx)(_Undo.default, {})
  });
}