"use strict";

var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getCellValueInRange;
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
/**
 * 获取单元格选中区域所有有效的值
 * 即：单元格内容的每行数据不能都是空字符串
 *
 * @param range
 * @param config
 * @returns
 */
function getCellValueInRange(range, config) {
  var _range = (0, _slicedToArray2.default)(range, 2),
    fromCell = _range[0],
    toCell = _range[1];
  var result = [];
  for (var i = fromCell[0]; i <= toCell[0]; i += 1) {
    for (var j = fromCell[1]; j <= toCell[1]; j += 1) {
      var _config$rows$i, _config$rows$i$cells, _config$rows$i$cells$;
      if ((_config$rows$i = config.rows[i]) !== null && _config$rows$i !== void 0 && (_config$rows$i$cells = _config$rows$i.cells) !== null && _config$rows$i$cells !== void 0 && (_config$rows$i$cells$ = _config$rows$i$cells[j]) !== null && _config$rows$i$cells$ !== void 0 && _config$rows$i$cells$.value) {
        var _config$rows$i$cells$2, _config$rows$i$cells$3;
        var flag = (_config$rows$i$cells$2 = config.rows[i].cells[j]) === null || _config$rows$i$cells$2 === void 0 ? void 0 : (_config$rows$i$cells$3 = _config$rows$i$cells$2.value) === null || _config$rows$i$cells$3 === void 0 ? void 0 : _config$rows$i$cells$3.some(function (cellValue) {
          var _cellValue$children = cellValue.children,
            children = _cellValue$children === void 0 ? [] : _cellValue$children;
          return children.some(function (item) {
            return !!item.text.trim();
          });
        });
        if (flag) {
          result.push(config.rows[i].cells[j].value);
        }
      }
    }
  }
  return result;
}