"use strict";

var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _objectSpread2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/objectSpread2"));
var _objectWithoutProperties2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/objectWithoutProperties"));
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
var _printOutCore = /*#__PURE__*/require("@sinoform/print-out-core");
var _react = /*#__PURE__*/require("react");
var _reactFastCompare = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("react-fast-compare"));
var _reactRedux = /*#__PURE__*/require("react-redux");
var _slate = /*#__PURE__*/require("slate");
var _slateHistory = /*#__PURE__*/require("slate-history");
var _slateReact = /*#__PURE__*/require("slate-react");
var _slateEditor = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../components/slate-editor"));
var _reducer = /*#__PURE__*/require("../reducer");
var _withShortcuts = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../utils/withShortcuts"));
var _excluded = ["horizontal", "vertical"];
function Td(_ref) {
  var _cell$style2, _cell$merge$, _cell$merge, _cell$merge$2, _cell$merge2, _cell$merge3, _cell$style3;
  var cell = _ref.cell,
    rowIdx = _ref.rowIdx,
    colIdx = _ref.colIdx,
    style = _ref.style,
    fields = _ref.fields,
    setEditor = _ref.setEditor,
    handleTdDoubleClick = _ref.handleTdDoubleClick,
    height = _ref.height,
    width = _ref.width;
  var dispatch = (0, _reactRedux.useDispatch)();
  var isEditing = (0, _reactRedux.useSelector)(function (reduxState) {
    var _reduxState$present$e;
    var _ref2 = (_reduxState$present$e = reduxState.present.editingCell) !== null && _reduxState$present$e !== void 0 ? _reduxState$present$e : [-1, -1],
      _ref3 = (0, _slicedToArray2.default)(_ref2, 2),
      rowIndex = _ref3[0],
      columnIndex = _ref3[1];
    return rowIndex === rowIdx && columnIndex === colIdx;
  });
  var horizontal = style.horizontal,
    vertical = style.vertical,
    border = (0, _objectWithoutProperties2.default)(style, _excluded);
  var editor = (0, _react.useMemo)(function () {
    return (0, _withShortcuts.default)((0, _slateHistory.withHistory)((0, _slateReact.withReact)((0, _slate.createEditor)())));
  }, []);
  var handleDoubleClick = (0, _react.useCallback)(function () {
    var pos = [rowIdx, colIdx];
    if (isEditing) {
      return;
    }
    dispatch({
      type: _reducer.ActionType.SET_EDITING_CELL,
      payload: pos
    });
    setEditor(editor);
    if (handleTdDoubleClick) {
      handleTdDoubleClick();
    }
    // 双击时让editor获取焦点
    setTimeout(function () {
      _slateReact.ReactEditor.focus(editor);
      if (editor.children && editor.children[0].children[0].text.length === 0) {
        editor.insertText(' ');
      }
      _slate.Transforms.setSelection(editor, {
        anchor: {
          path: [0, 0],
          offset: 1
        },
        focus: {
          path: [0, 0],
          offset: 1
        }
      });
    });
  }, [rowIdx, colIdx, isEditing, dispatch, setEditor, editor, handleTdDoubleClick]);
  var getReadOnlyValue = function getReadOnlyValue(cellValue) {
    if (!cellValue) {
      return [];
    }
    return cellValue.map(function (item) {
      return {
        segment: item
      };
    });
  };
  var tdStyle = (0, _react.useMemo)(function () {
    var _cell$style;
    return (0, _objectSpread2.default)((0, _objectSpread2.default)({}, border), {}, {
      backgroundColor: cell !== null && cell !== void 0 && (_cell$style = cell.style) !== null && _cell$style !== void 0 && _cell$style.backgroundColor ? cell.style.backgroundColor : 'transparent'
    });
  }, [border, cell === null || cell === void 0 ? void 0 : (_cell$style2 = cell.style) === null || _cell$style2 === void 0 ? void 0 : _cell$style2.backgroundColor]);
  return (0, _jsxRuntime.jsx)("td", {
    className: "custom-print-table-td",
    id: "".concat(rowIdx, "-").concat(colIdx),
    colSpan: ((_cell$merge$ = cell === null || cell === void 0 ? void 0 : (_cell$merge = cell.merge) === null || _cell$merge === void 0 ? void 0 : _cell$merge[1]) !== null && _cell$merge$ !== void 0 ? _cell$merge$ : 0) + 1,
    rowSpan: ((_cell$merge$2 = cell === null || cell === void 0 ? void 0 : (_cell$merge2 = cell.merge) === null || _cell$merge2 === void 0 ? void 0 : _cell$merge2[0]) !== null && _cell$merge$2 !== void 0 ? _cell$merge$2 : 0) + 1,
    style: tdStyle,
    height: height,
    "data-rowid": rowIdx,
    "data-colid": colIdx,
    "data-merge": JSON.stringify((_cell$merge3 = cell === null || cell === void 0 ? void 0 : cell.merge) !== null && _cell$merge3 !== void 0 ? _cell$merge3 : [0, 0]),
    onDoubleClick: handleDoubleClick,
    children: (0, _jsxRuntime.jsx)("div", {
      style: {
        width: '100%',
        height: "".concat(height, "px"),
        display: 'flex',
        overflow: 'hidden',
        textAlign: horizontal !== null && horizontal !== void 0 ? horizontal : 'left',
        alignItems: vertical !== null && vertical !== void 0 ? vertical : 'center'
      },
      children: !isEditing ? (0, _jsxRuntime.jsx)(_printOutCore.CellValueRenderer, {
        value: getReadOnlyValue(cell === null || cell === void 0 ? void 0 : cell.value),
        fields: fields,
        isInDesigner: true
      }) : (0, _jsxRuntime.jsx)(_slateEditor.default, {
        value: cell === null || cell === void 0 ? void 0 : cell.value,
        editor: editor,
        bgColor: cell === null || cell === void 0 ? void 0 : (_cell$style3 = cell.style) === null || _cell$style3 === void 0 ? void 0 : _cell$style3.backgroundColor,
        width: width,
        rowIdx: rowIdx,
        colIdx: colIdx,
        fields: fields
      })
    })
  });
}
// eslint-disable-next-line react/display-name
var TdComp = /*#__PURE__*/(0, _react.memo)(Td, function (prev, next) {
  if (!(0, _reactFastCompare.default)(prev.cell, next.cell) || !(0, _reactFastCompare.default)(prev.style, next.style) || prev.width !== next.width || prev.height !== next.height) {
    return false;
  }
  return true;
});
var _default = TdComp;
exports.default = _default;