import { CellPos, CellRange } from '../types';
/**
 * 计算选中单元格的区域
 *
 * 如果选中区域存在合并的单元格区域超出了选中的边界，需要将选中区域拓展到新的边界，
 * 如果拓展后的边界重新触发了该规则，则递归进行计算
 *
 * @param startPos 选中区域起始位置
 * @param endPos   选中区域结束位置
 * @param merges   所有单元格的合并信息
 */
export default function calcCellRange(startPos: CellPos, endPos: CellPos, merges?: CellRange[]): CellRange;
