"use strict";

var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
var _slate = /*#__PURE__*/require("slate");
var CustomEditor = {
  isBoldMarkActive: function isBoldMarkActive(editor) {
    var _Editor$nodes = _slate.Editor.nodes(editor, {
        match: function match(n) {
          return n.bold === true;
        },
        universal: true
      }),
      _Editor$nodes2 = (0, _slicedToArray2.default)(_Editor$nodes, 1),
      match = _Editor$nodes2[0];
    return !!match;
  },
  isItalicActive: function isItalicActive(editor) {
    var _Editor$nodes3 = _slate.Editor.nodes(editor, {
        match: function match(n) {
          return n.italic === true;
        }
      }),
      _Editor$nodes4 = (0, _slicedToArray2.default)(_Editor$nodes3, 1),
      match = _Editor$nodes4[0];
    return !!match;
  },
  isUnderLineMarkActive: function isUnderLineMarkActive(editor) {
    var _Editor$nodes5 = _slate.Editor.nodes(editor, {
        match: function match(n) {
          return n.underLine === true;
        }
      }),
      _Editor$nodes6 = (0, _slicedToArray2.default)(_Editor$nodes5, 1),
      match = _Editor$nodes6[0];
    return !!match;
  },
  isDeleteLineMarkActive: function isDeleteLineMarkActive(editor) {
    var _Editor$nodes7 = _slate.Editor.nodes(editor, {
        match: function match(n) {
          return n.deleteLine === true;
        }
      }),
      _Editor$nodes8 = (0, _slicedToArray2.default)(_Editor$nodes7, 1),
      match = _Editor$nodes8[0];
    return !!match;
  },
  getFontFamily: function getFontFamily(editor) {
    var _match$;
    var _Editor$nodes9 = _slate.Editor.nodes(editor, {
        match: function match(n) {
          return !!n.fontFamily;
        }
      }),
      _Editor$nodes10 = (0, _slicedToArray2.default)(_Editor$nodes9, 1),
      match = _Editor$nodes10[0];
    return match && ((_match$ = match[0]) === null || _match$ === void 0 ? void 0 : _match$.fontFamily);
  },
  getFontSize: function getFontSize(editor) {
    var _match$2;
    var _Editor$nodes11 = _slate.Editor.nodes(editor, {
        match: function match(n) {
          return !!n.fontSize;
        }
      }),
      _Editor$nodes12 = (0, _slicedToArray2.default)(_Editor$nodes11, 1),
      match = _Editor$nodes12[0];
    return match && ((_match$2 = match[0]) === null || _match$2 === void 0 ? void 0 : _match$2.fontSize);
  },
  toggleBoldMark: function toggleBoldMark(editor) {
    var isActive = CustomEditor.isBoldMarkActive(editor);
    _slate.Transforms.setNodes(editor, {
      bold: isActive ? undefined : true
    }, {
      match: function match(n) {
        return _slate.Text.isText(n);
      },
      split: true
    });
  },
  toggleItalicMark: function toggleItalicMark(editor) {
    var isActive = CustomEditor.isItalicActive(editor);
    _slate.Transforms.setNodes(editor, {
      italic: isActive ? null : true
    }, {
      match: function match(n) {
        return _slate.Text.isText(n);
      },
      split: true
    });
  },
  toggleUnderLineMark: function toggleUnderLineMark(editor) {
    var isActive = CustomEditor.isUnderLineMarkActive(editor);
    _slate.Transforms.setNodes(editor, {
      underLine: isActive ? null : true
    }, {
      match: function match(n) {
        return _slate.Text.isText(n);
      },
      split: true
    });
  },
  toggleDeleteLineMark: function toggleDeleteLineMark(editor) {
    var isActive = CustomEditor.isDeleteLineMarkActive(editor);
    _slate.Transforms.setNodes(editor, {
      deleteLine: isActive ? null : true
    }, {
      match: function match(n) {
        return _slate.Text.isText(n);
      },
      split: true
    });
  },
  changeTextColor: function changeTextColor(editor, color) {
    _slate.Transforms.setNodes(editor, {
      color: color
    }, {
      match: function match(n) {
        return _slate.Text.isText(n);
      },
      split: true
    });
  },
  toggeleFontSize: function toggeleFontSize(editor, fontSize) {
    _slate.Transforms.setNodes(editor, {
      fontSize: fontSize
    }, {
      match: function match(n) {
        return _slate.Text.isText(n);
      },
      split: true
    });
  },
  toggeleFontFamily: function toggeleFontFamily(editor, fontFamily) {
    _slate.Transforms.setNodes(editor, {
      fontFamily: fontFamily
    }, {
      match: function match(n) {
        return _slate.Text.isText(n);
      },
      split: true
    });
  }
};
var _default = CustomEditor;
exports.default = _default;